install.sh 8.0 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263
  1. #!/bin/sh
  2. # This script installs Ollama on Linux.
  3. # It detects the current operating system architecture and installs the appropriate version of Ollama.
  4. set -eu
  5. status() { echo ">>> $*" >&2; }
  6. error() { echo "ERROR $*"; exit 1; }
  7. warning() { echo "WARNING: $*"; }
  8. TEMP_DIR=$(mktemp -d)
  9. cleanup() { rm -rf $TEMP_DIR; }
  10. trap cleanup EXIT
  11. available() { command -v $1 >/dev/null; }
  12. require() {
  13. local MISSING=''
  14. for TOOL in $*; do
  15. if ! available $TOOL; then
  16. MISSING="$MISSING $TOOL"
  17. fi
  18. done
  19. echo $MISSING
  20. }
  21. [ "$(uname -s)" = "Linux" ] || error 'This script is intended to run on Linux only.'
  22. ARCH=$(uname -m)
  23. case "$ARCH" in
  24. x86_64) ARCH="amd64" ;;
  25. aarch64|arm64) ARCH="arm64" ;;
  26. *) error "Unsupported architecture: $ARCH" ;;
  27. esac
  28. SUDO=
  29. if [ "$(id -u)" -ne 0 ]; then
  30. # Running as root, no need for sudo
  31. if ! available sudo; then
  32. error "This script requires superuser permissions. Please re-run as root."
  33. fi
  34. SUDO="sudo"
  35. fi
  36. NEEDS=$(require curl awk grep sed tee xargs)
  37. if [ -n "$NEEDS" ]; then
  38. status "ERROR: The following tools are required but missing:"
  39. for NEED in $NEEDS; do
  40. echo " - $NEED"
  41. done
  42. exit 1
  43. fi
  44. status "Downloading ollama..."
  45. curl --fail --show-error --location --progress-bar -o $TEMP_DIR/ollama "https://ollama.ai/download/ollama-linux-$ARCH"
  46. for BINDIR in /usr/local/bin /usr/bin /bin; do
  47. echo $PATH | grep -q $BINDIR && break || continue
  48. done
  49. status "Installing ollama to $BINDIR..."
  50. $SUDO install -o0 -g0 -m755 -d $BINDIR
  51. $SUDO install -o0 -g0 -m755 $TEMP_DIR/ollama $BINDIR/ollama
  52. install_success() {
  53. status 'The Ollama API is now available at 0.0.0.0:11434.'
  54. status 'Install complete. Run "ollama" from the command line.'
  55. }
  56. trap install_success EXIT
  57. # Everything from this point onwards is optional.
  58. configure_systemd() {
  59. if ! id ollama >/dev/null 2>&1; then
  60. status "Creating ollama user..."
  61. $SUDO useradd -r -s /bin/false -m -d /usr/share/ollama ollama
  62. fi
  63. status "Adding current user to ollama group..."
  64. $SUDO usermod -a -G ollama $(whoami)
  65. status "Creating ollama systemd service..."
  66. cat <<EOF | $SUDO tee /etc/systemd/system/ollama.service >/dev/null
  67. [Unit]
  68. Description=Ollama Service
  69. After=network-online.target
  70. [Service]
  71. ExecStart=$BINDIR/ollama serve
  72. User=ollama
  73. Group=ollama
  74. Restart=always
  75. RestartSec=3
  76. Environment="PATH=$PATH"
  77. [Install]
  78. WantedBy=default.target
  79. EOF
  80. mkdir -p /etc/systemd/system/ollama.service.d
  81. cat <<EOF | $SUDO tee /etc/systemd/system/ollama.service.d/environment.conf >/dev/null
  82. [Service]
  83. #Environment="OLLAMA_HOST="
  84. #Environment="OLLAMA_ORIGINS="
  85. #Environment="OLLAMA_MODELS="
  86. #Environment="HTTPS_PROXY="
  87. EOF
  88. SYSTEMCTL_RUNNING="$(systemctl is-system-running || true)"
  89. case $SYSTEMCTL_RUNNING in
  90. running|degraded)
  91. status "Enabling and starting ollama service..."
  92. $SUDO systemctl daemon-reload
  93. $SUDO systemctl enable ollama
  94. start_service() { $SUDO systemctl restart ollama; }
  95. trap start_service EXIT
  96. ;;
  97. esac
  98. }
  99. if available systemctl; then
  100. configure_systemd
  101. fi
  102. if ! available lspci && ! available lshw; then
  103. warning "Unable to detect NVIDIA GPU. Install lspci or lshw to automatically detect and install NVIDIA CUDA drivers."
  104. exit 0
  105. fi
  106. check_gpu() {
  107. case $1 in
  108. lspci) available lspci && lspci -d '10de:' | grep -q 'NVIDIA' || return 1 ;;
  109. lshw) available lshw && $SUDO lshw -c display -numeric | grep -q 'vendor: .* \[10DE\]' || return 1 ;;
  110. nvidia-smi) available nvidia-smi || return 1 ;;
  111. esac
  112. }
  113. if check_gpu nvidia-smi; then
  114. status "NVIDIA GPU installed."
  115. exit 0
  116. fi
  117. if ! check_gpu lspci && ! check_gpu lshw; then
  118. install_success
  119. warning "No NVIDIA GPU detected. Ollama will run in CPU-only mode."
  120. exit 0
  121. fi
  122. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-7-centos-7
  123. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-8-rocky-8
  124. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-9-rocky-9
  125. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#fedora
  126. install_cuda_driver_yum() {
  127. status 'Installing NVIDIA repository...'
  128. case $PACKAGE_MANAGER in
  129. yum)
  130. $SUDO $PACKAGE_MANAGER -y install yum-utils
  131. $SUDO $PACKAGE_MANAGER-config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  132. ;;
  133. dnf)
  134. $SUDO $PACKAGE_MANAGER config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  135. ;;
  136. esac
  137. case $1 in
  138. rhel)
  139. status 'Installing EPEL repository...'
  140. # EPEL is required for third-party dependencies such as dkms and libvdpau
  141. $SUDO $PACKAGE_MANAGER -y install https://dl.fedoraproject.org/pub/epel/epel-release-latest-$2.noarch.rpm || true
  142. ;;
  143. esac
  144. status 'Installing CUDA driver...'
  145. if [ "$1" = 'centos' ] || [ "$1$2" = 'rhel7' ]; then
  146. $SUDO $PACKAGE_MANAGER -y install nvidia-driver-latest-dkms
  147. fi
  148. $SUDO $PACKAGE_MANAGER -y install cuda-drivers
  149. }
  150. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#ubuntu
  151. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#debian
  152. install_cuda_driver_apt() {
  153. status 'Installing NVIDIA repository...'
  154. curl -fsSL -o $TEMP_DIR/cuda-keyring.deb https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-keyring_1.1-1_all.deb
  155. case $1 in
  156. debian)
  157. status 'Enabling contrib sources...'
  158. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list | $SUDO tee /etc/apt/sources.list.d/contrib.list > /dev/null
  159. if [ -f "/etc/apt/sources.list.d/debian.sources" ]; then
  160. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list.d/debian.sources | $SUDO tee /etc/apt/sources.list.d/contrib.sources > /dev/null
  161. fi
  162. ;;
  163. esac
  164. status 'Installing CUDA driver...'
  165. $SUDO dpkg -i $TEMP_DIR/cuda-keyring.deb
  166. $SUDO apt-get update
  167. [ -n "$SUDO" ] && SUDO_E="$SUDO -E" || SUDO_E=
  168. DEBIAN_FRONTEND=noninteractive $SUDO_E apt-get -y install cuda-drivers -q
  169. }
  170. if [ ! -f "/etc/os-release" ]; then
  171. error "Unknown distribution. Skipping CUDA installation."
  172. fi
  173. . /etc/os-release
  174. OS_NAME=$ID
  175. OS_VERSION=$VERSION_ID
  176. PACKAGE_MANAGER=
  177. for PACKAGE_MANAGER in dnf yum apt-get; do
  178. if available $PACKAGE_MANAGER; then
  179. break
  180. fi
  181. done
  182. if [ -z "$PACKAGE_MANAGER" ]; then
  183. error "Unknown package manager. Skipping CUDA installation."
  184. fi
  185. if ! check_gpu nvidia-smi || [ -z "$(nvidia-smi | grep -o "CUDA Version: [0-9]*\.[0-9]*")" ]; then
  186. case $OS_NAME in
  187. centos|rhel) install_cuda_driver_yum 'rhel' $OS_VERSION ;;
  188. rocky) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -c1) ;;
  189. fedora) install_cuda_driver_yum $OS_NAME $OS_VERSION ;;
  190. amzn) install_cuda_driver_yum 'fedora' '35' ;;
  191. debian) install_cuda_driver_apt $OS_NAME $OS_VERSION ;;
  192. ubuntu) install_cuda_driver_apt $OS_NAME $(echo $OS_VERSION | sed 's/\.//') ;;
  193. *) exit ;;
  194. esac
  195. fi
  196. if ! lsmod | grep -q nvidia; then
  197. KERNEL_RELEASE="$(uname -r)"
  198. case $OS_NAME in
  199. centos|rhel|rocky|amzn) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE kernel-headers-$KERNEL_RELEASE ;;
  200. fedora) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE ;;
  201. debian|ubuntu) $SUDO apt-get -y install linux-headers-$KERNEL_RELEASE ;;
  202. *) exit ;;
  203. esac
  204. NVIDIA_CUDA_VERSION=$($SUDO dkms status | awk -F: '/added/ { print $1 }')
  205. if [ -n "$NVIDIA_CUDA_VERSION" ]; then
  206. $SUDO dkms install $NVIDIA_CUDA_VERSION
  207. fi
  208. if lsmod | grep -q nouveau; then
  209. status 'Reboot to complete NVIDIA CUDA driver install.'
  210. exit 0
  211. fi
  212. $SUDO modprobe nvidia
  213. fi
  214. status "NVIDIA CUDA drivers installed."